// Sample DBClass program - compile as a Win32 console app
//
// This demostrates how to use the class.  Sorry, but you'll have to 
// supply your own test database.  cool.mdb does not exist.

#include <stdio.h>
#include <windows.h>		// windows.h MUST be included in any program using DBClass
#include "dbclass.h"		// dbclass.h MUST be included in any program using DBClass

void test_read(void)
{
	Database db;
	Recordset rs(db);
	char name[256];
	int age;

	// Open the database
	db.open("cool.mdb");

	// Setup a query
	rs.query("SELECT Name, Age FROM Table1");
	rs.parameter(SQL_C_CHAR, name, sizeof(name));
	rs.parameter(SQL_C_LONG, &age, sizeof(age));

	// Keep executing the query until there's no more data
	while (SQL_SUCCEEDED(rs.execute_query()))
	{
		printf("Name: %s\n", name);
		printf("Age: %d\n", age);
	}

	// Setup an equivalent query but without hard-coded column bindings
	rs.query("SELECT * FROM Table2");
	rs.named_parameter("Name", SQL_C_CHAR, name, sizeof(name));
	rs.named_parameter("Age", SQL_C_LONG, &age, sizeof(age));

	// Keep executing the query until there's no more data
	while (SQL_SUCCEEDED(rs.execute_query()))
	{
		printf("Name: %s\n", name);
		printf("Age: %d\n", age);
	}

	// Close the database
	db.close();
}

void test_write(void)
{
	Database db("cool.mdb");	// Note the alternate constructor
	Recordset rs(db);
	char *name = "";
	int age = 18;

	rs.query("INSERT INTO TABLE1(NAME, AGE) VALUES (?,?)");
	rs.parameter(SQL_C_CHAR, name, strlen(name));
	rs.parameter(SQL_C_LONG, &age, sizeof(age));
	rs.execute_query();
}

int main(void)
{
	test_write();
	test_read();

	return 0;
}